#version 110

// This is a simple GLSL fragment shader example,
// drawing sinusoidal rainbow pattern.
// Author: Dmitri Kuvshinov.

// shader parameters

uniform sampler1D palette;
uniform float t;
uniform float pixel_units_coef;
uniform float width, height;

// rotate
vec2 rot2(vec2 p, float angle)
{
  float s = sin(angle), c = cos(angle);
  return vec2(c*p.x - s*p.y, s*p.x + c*p.y);
}

// ellipse
bool ellipse(vec2 p, vec2 r)
{
  p /= r;
  return dot(p, p) <= 1.;
}

// indicator
bool indicator(vec2 p)
{
  return ellipse(rot2(p - vec2(4, 4), 0.2*t), vec2(1, 3));
}

// shader procedure
void main(void)
{
  gl_FragColor = texture1D(palette, (indicator(pixel_units_coef*gl_FragCoord.xy)? width/height : 0.33));
}
