﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file EnterNameScreen.hpp
 *
 * Экран 3. Ввод имени игрока (для отображения в списке лучших, если, конечно, он туда попадёт).
 */
#pragma once
#include "DemoGameScreen.hpp"
#include <string>

/// класс, реализующий экран ввода имени игрока, закончившего игру
class Enter_name_screen: public Demo_game_screen
{
public:

  /// внешний обработчик события "имя введено"
  using Name_entered_handler = std::function<void(const std::string&)>;
  /// привязать обработчик события "имя введено"
  void set_name_entered_handler(Name_entered_handler handler)
  {
    do_transmit_name = handler;
  }

  /// выставить текущие очки (передаётся уже готовое строковое представление)
  void set_score(const std::string &sc)
  {
    name.clear();
    score = sc;
  }

protected:

  void on_display() override;
  void on_char(unsigned char code, int, int) override;

private:

  using Base = Demo_game_screen;
  Name_entered_handler do_transmit_name;
  std::string name, score;
};
