﻿/*
 * This file is part of AV Orchid.
 * Copyright (c) 2013, Dmitri R. Kuvshinov <evetro.here@gmail.com>
 * 
 * Permission to use, copy, modify, and/or distribute this software for
 * any purpose with or without fee is hereby granted, provided that the
 * above copyright notice and this permission notice appear in all copies.
 * 
 * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
 * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
 * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
 * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
 * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
 * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
 * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
 */
/**
 * @file HallOfFameScreen.hpp
 *
 * Экран 1. Список лучших игроков.
 */
#pragma once
#include "DemoGameScreen.hpp"


/// экран "список лучших" + демо (змея движится под действием случайного управления)
class Hall_of_fame_screen : public Demo_game_screen
{
public:

  Hall_of_fame_screen();
  ~Hall_of_fame_screen() override;

  /// добавить в список игрока
  /** 
   * @param name имя добавляемого игрока
   * @param score количество заработанных очков
   */
  void add_player(Score score, const std::string &name);

  /// внешний обработчик события "игра начата"
  using Game_started_handler = std::function<void()>;
  /// привязать обработчик события "игра начата"
  void set_game_started_handler(Game_started_handler handler)
  {
    do_game_start = handler;
  }

protected:

  void on_select() override;
  void on_display() override;
  void on_char(unsigned char code, int, int) override;

private:

  using Base = Demo_game_screen;
  class Hall_of_fame_impl *impl; // pimpl
  Game_started_handler do_game_start;
};
